> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nx1cloud.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Register a package mirror



## OpenAPI

````yaml post /api/package-sources
openapi: 3.1.0
info:
  title: Nx1 AI API
  description: |

    AI API for Nx1 Data Platform Management and Automated Data Tasks.

    Authentication is required via PSK in Authorization header.

    Default PSK is | [ask a friend] |
  version: 0.10.2
servers: []
security: []
paths:
  /api/package-sources:
    post:
      tags:
        - Package sources
      summary: Register a package mirror
      operationId: create_package_source_api_package_sources_post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PackageSourceCreate'
        required: true
      responses:
        '201':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PackageSourceDetail'
        '409':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Conflict
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - OAuth2AuthorizationCodeBearer: []
        - APIKeyHeader: []
components:
  schemas:
    PackageSourceCreate:
      properties:
        name:
          type: string
          title: Name
          description: Lowercase letters, digits and '-'; 1–40 characters.
        index_url:
          type: string
          title: Index Url
          description: pip index URL of the mirror (the /simple endpoint).
        ca_cert_pem:
          anyOf:
            - type: string
            - type: 'null'
          title: Ca Cert Pem
          description: PEM CA certificate if the mirror uses an internal CA.
        enabled:
          type: boolean
          title: Enabled
          default: true
      type: object
      required:
        - name
        - index_url
      title: PackageSourceCreate
    PackageSourceDetail:
      properties:
        name:
          type: string
          title: Name
        kind:
          $ref: '#/components/schemas/PackageSourceKind'
        enabled:
          type: boolean
          title: Enabled
        is_default:
          type: boolean
          title: Is Default
        description:
          type: string
          title: Description
        index_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Index Url
        ca_cert_pem:
          anyOf:
            - type: string
            - type: 'null'
          title: Ca Cert Pem
      type: object
      required:
        - name
        - kind
        - enabled
        - is_default
        - description
      title: PackageSourceDetail
    ErrorResponse:
      properties:
        error:
          type: string
          title: Error
          description: A brief description of the error that occurred.
        code:
          type: integer
          title: Code
          description: The HTTP status code associated with the error.
          default: 500
      type: object
      required:
        - error
      title: ErrorResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    PackageSourceKind:
      type: string
      enum:
        - pypi
        - mirror
        - preinstalled
      title: PackageSourceKind
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    OAuth2AuthorizationCodeBearer:
      type: oauth2
      flows:
        authorizationCode:
          scopes: {}
          authorizationUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/auth
          tokenUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/token
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization-PSK

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.